<?php
/**************************************************
  Coppermine 1.4.x Plugin - CPG XFeed $VERSION$=1.0
  *************************************************
  Copyright (c) 2008 lee (www.mininoteuser.com)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  **************************************************/
  
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// RSS Button
$thisplugin->add_filter('gallery_header','xfd_rss_button');

// Add page start action for admin button.
$thisplugin->add_action('page_start','xfd_page_start');

// Add filter for page head
$thisplugin->add_filter('page_meta','xfd_head');

// Add plugin_install action
$thisplugin->add_action('plugin_install','xfd_install');

// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','xfd_uninstall');

// get settings
global $XFDSET,$lang_xfeeds;
require('./plugins/cpg-xfeed/include/load_xfdset.php');


// rss button
function xfd_rss_button()
{
global $XFDSET,$lang_xfeeds,$CONFIG;
require('./plugins/cpg-xfeed/include/init.inc.php');

if ($XFDSET['xfd_feedroute'] == 1) {
	$xfeed_loc = "feeds.feedburner.com/".$XFDSET['xfd_feedburnuname'];
} else {
	$xfeed_loc = "".str_replace("http://","",$CONFIG[ecards_more_pic_target])."xfeed.php";
}

//static
$xfeed_title_enc = urlencode($CONFIG['gallery_name']);
$xfeed_author = "Admin"; // maybe get the first username in the future.

$java = "
<!-- BEGIN XFeeds Plugin -->

	<span style=\"padding-left: 100px;\" id=\"jquery_xfeed\"></span><script type=\"text/javascript\">//<![CDATA[
	var oCustomLinks = [

";

if ($XFDSET['xfd_standard'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_standard']."',";
	$java .= "	\n\t href:\"".$CONFIG[ecards_more_pic_target]."xfeed.php\" },\n";
} 
if ($XFDSET['xfd_google'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_google']."',";
	$java .= "	\n\t href:\"http://fusion.google.com/add?feedurl=http%3A//".$xfeed_loc."\" },\n";
}
if ($XFDSET['xfd_yahoo'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_yahoo']."',";
	$java .= "	\n\t href:\"http://us.rd.yahoo.com/my/atm/".$xfeed_author."/".$xfeed_title_enc."http%3A//".$xfeed_loc."\" },\n";
}
if ($XFDSET['xfd_msn'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_msn']."',";
	$java .= "	\n\t href:\"http://my.msn.com/addtomymsn.armx?id=rss&amp;ut=http://".$xfeed_loc."\" },\n";
}
if ($XFDSET['xfd_lines'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_lines']."',";
	$java .= "	\n\t href:\"http://www.bloglines.com/sub/http://".$xfeed_loc."\" },\n";
}
if ($XFDSET['xfd_aol'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_aol']."',";
	$java .= "	\n\t href:\"http://feeds.my.aol.com/add.jsp?url=http://".$xfeed_loc."\" },\n";
}
if ($XFDSET['xfd_feedburn'] == 1) {
	$java .= "	{ title:'".$lang_xfeeds['xfd_fe_feedburn']."',";
	$java .= "	\n\t href:\"http://feeds.feedburner.com/".$XFDSET['xfd_feedburnuname']."\" },\n";
}
if ($XFDSET['xfd_customenable1'] == 1) {
	$java .= "	{ title:'".$XFDSET['xfd_customtitle1']."',";
	$java .= "	\n\t href:\"".$XFDSET['xfd_customurl1']."\" },\n";
}
if ($XFDSET['xfd_customenable2'] == 1) {
	$java .= "	{ title:'".$XFDSET['xfd_customtitle2']."',";
	$java .= "	\n\t href:\"".$XFDSET['xfd_customurl2']."\" },\n";
}
if ($XFDSET['xfd_customenable3'] == 1) {
	$java .= "	{ title:'".$XFDSET['xfd_customtitle3']."',";
	$java .= "	\n\t href:\"".$XFDSET['xfd_customurl3']."\" },\n";
}
if ($XFDSET['xfd_customenable4'] == 1) {
	$java .= "	{ title:'".$XFDSET['xfd_customtitle4']."',";
	$java .= "	\n\t href:\"".$XFDSET['xfd_customurl4']."\" },\n";
}
if ($XFDSET['xfd_customenable5'] == 1) {
	$java .= "	{ title:'".$XFDSET['xfd_customtitle5']."',";
	$java .= "	\n\t href:\"".$XFDSET['xfd_customurl5']."\" },\n";
}

$java .= "
	];
	var fm9 = new FeedMenu(oCustomLinks);
	fm9.write('#jquery_xfeed');
	//]]>
	</script>

<!-- END XFeeds Plugin -->
";

return $java;

}


// include header elements
function xfd_head()
{        

	global $thisplugin, $XFDSET;

	switch ($XFDSET['xfd_theme']) {
	case 0:
	    $color = "orange";
	    break;
	case 1:
	    $color = "azure";
	    break;
	case 2:
	    $color = "wood";
	    break;
	case 3:
	    $color = "trans_dark";
	    break;
	case 4:
	    $color = "trans_light";
	    break;
	}

	$header = "
	<!-- Begin CPG XFeed Headcode -->
	<script type=\"text/javascript\" src=\"plugins/cpg-xfeed/js/jquery.js\"></script>
	<script type=\"text/javascript\" src=\"plugins/cpg-xfeed/js/feed_menu.js\"></script>
	<script type=\"text/javascript\">
		$ = jQuery;
	</script>
	<link rel=\"stylesheet\" href=\"plugins/cpg-xfeed/css/feed_menu.css\" type=\"text/css\" />

	<style>
		.feed_menu{ background: url(plugins/cpg-xfeed/images/feed_menu_".$color.".png) 0 center no-repeat;}
	</style>
	<!-- END CPG XFeed Headcode -->
	";

	return $header;

}

// add config button
function xfd_add_config_button($href,$title,$target,$link)
{
  global $template_gallery_admin_menu;
  $new_template = $template_gallery_admin_menu;
  $button = template_extract_block($new_template,'documentation');
  $params = array(
      '{DOCUMENTATION_HREF}' => $href,
      '{DOCUMENTATION_TITLE}' => $title,
      'target="cpg_documentation"' => $target,
      '{DOCUMENTATION_LNK}' => $link,
   );
   $new_button="<!-- BEGIN $link -->".template_eval($button,$params)."<!-- END $link -->\n";
   template_extract_block($template_gallery_admin_menu,'documentation',"<!-- BEGIN documentation -->" . $button . "<!-- END documentation -->\n" . $new_button);
}

function xfd_page_start()
{ 
  if (GALLERY_ADMIN_MODE) {
    xfd_add_config_button('index.php?file=cpg-xfeed/plugin_config','','','XFeeds');
  } 
}

// Install
function xfd_install()
{
                global $CONFIG, $thisplugin;
                require 'include/sql_parse.php';

		copy("plugins/cpg-xfeed/xfeed.php","xfeed.php");

                // create table
                $db_schema = $thisplugin->fullpath . '/schema.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');
                echo $sqlquery;
                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }
                
                // insert default values
                $db_schema = $thisplugin->fullpath . '/basic.sql';
                $sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
                $sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);
                $sql_query = remove_remarks($sql_query);
                $sql_query = split_sql_file($sql_query, ';');
              
                foreach($sql_query as $q) { 
                  cpg_db_query($q);
                }

		return true;

}


// Unnstall and drop settings table
function xfd_uninstall()
{
        global $CONFIG;
        cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PREFIX']}plugin_xfeeds");
	unlink("xfeed.php");
        return true;
}

?>